//code for the OOT dance, coded by Emmette Clyde

local SkinCheck = Echoes.SkinCheck
local FailVibeCheck = Echoes.FailVibeCheck
local JumpManager = Echoes.JumpManager
local StateSetter = Echoes.StateSetter
local FoxOnGround = Echoes.FoxOnGround
local StateReset = Echoes.StateReset
local PlayerCam = Echoes.PlayerCam
local SpeedCalc = Echoes.SpeedCalc

Echoes.YoureOuttaTouch = function(player)
	if not SkinCheck(player)
		return
	end
	
	local echoes = player.echoes
	//failsafe
	if FailVibeCheck(player) or player.pflags & PF_JUMPED or 
			echoes.transform >= 0 or echoes.voidtumble or 
			(not FoxOnGround(player.mo) and player.mo.state != S_OUTOFTOUCH3)
			or player.mo.state == S_PLAY_LOVERS_HUG or player.skipsmug
		if echoes.outoftouch and echoes.transform < 0 and not player.skipsmug
			P_RestoreMusic(player)
		end
		echoes.outoftouch = false
		echoes.ootstate = S_NULL
		echoes.ootframe = -1
		return
	end
	
	//setting up custom 2 press for dance trigger
	if player.cmd.buttons & BT_CUSTOM2 and not echoes.cust2press
		echoes.cust2press = true
	elseif not (player.cmd.buttons & BT_CUSTOM2) and echoes.cust2press
		echoes.cust2press = false
	end
	//set up input buffer
	if echoes.cust2press
		echoes.cust2buffer = $ + 1
	elseif echoes.cust2buffer > 0
		echoes.cust2buffer = 0
	end
	//trigger actual dance
	if echoes.cust2press and SpeedCalc(player) == 0 and 
			(player.cmd.buttons & BT_TOSSFLAG and not echoes.tosspress)
			and not echoes.outoftouch and echoes.cust2buffer > 2
		S_ChangeMusic("THURSDAY", true, player, 0, 0, 0, 0)
		echoes.outoftouch = true
		echoes.tosspress = true
		player.mo.state = S_OUTOFTOUCH1
	end
	//set up tossflag press
	if player.cmd.buttons & BT_TOSSFLAG and not echoes.tosspress
		echoes.tosspress = true
	elseif not (player.cmd.buttons & BT_TOSSFLAG) and echoes.tosspress
		echoes.tosspress = false
	end
	//actual thinker for dance
	if echoes.outoftouch
		//player.pflags = $ | PF_STASIS
		--local pcam = PlayerCam(player)
		local pang = player.mo.angle
		local sped = player.mo.scale + player.cmomx + player.cmomy
		local fram = player.mo.frame & FF_FRAMEMASK
		Skipchoes.FunkyParticles(player.mo)
		if player.mo.state == S_OUTOFTOUCH1
			if fram == 2 or fram == 3 or fram == 7 or fram == 8
				P_InstaThrust(player.mo, pang - ANGLE_90, sped)
			elseif fram == 12 or fram == 13 or fram == 17 or fram == 18
				P_InstaThrust(player.mo, pang + ANGLE_90, sped)
			end
		elseif player.mo.state == S_OUTOFTOUCH2
			if fram == 1 or fram == 2
				P_InstaThrust(player.mo, pang + ANGLE_90, sped)
			elseif fram == 6 or fram == 7
				P_InstaThrust(player.mo, pang - ANGLE_90, sped)
			end
		elseif player.mo.state == S_OUTOFTOUCH3
			sped = $ + player.mo.scale * 2
			if fram == 2 or fram == 7
				P_SpawnSkidDust(player, player.mo.radius)
				if fram == 2
					P_InstaThrust(player.mo, pang - ANGLE_90, sped)
				else
					P_InstaThrust(player.mo, pang + ANGLE_90, sped)
				end
			end
		else
			echoes.outoftouch = false
			P_RestoreMusic(player)
		end
	else
		StateReset(player.mo, {S_OUTOFTOUCH1, S_OUTOFTOUCH2, S_OUTOFTOUCH3})
	end
end

//simple function to disable movement inputs while doing the oot dance
local function OOTInputDisable(player, cmd)
	if not SkinCheck(player) or (player.echoes != nil and not 
			player.echoes.outoftouch)
		return
	end
	
	cmd.forwardmove = 0
	cmd.sidemove = 0
end

//hooks
addHook("PlayerCmd", OOTInputDisable)