//HUD stuff for Echoes, including debugging, coded by Emmette Clyde & Fav

local SkinCheck = Echoes.SkinCheck
local isSuper = Echoes.isSuper
local IsNiGHTS = Echoes.IsNiGHTS

// Toggle the Debug hud in case we need to test more shit lol
COM_AddCommand("echoes_debug", function(player, arg)
	if not (player.valid) then CONS_Printf(player, "You need to be in a level to use this.") return end
	if player.echoes == nil or player.echoes.DebugGUIPlease == nil then
		CONS_Printf(player, "This only works on Echoes!")
		return
	end
	if arg
		if arg == "on" or arg == "true" or arg == "1"
			player.echoes.DebugGUIPlease = true
			CONS_Printf(player, "Echoes debug GUI are now on.")
		elseif arg == "0" or arg == "false" or arg == "off"
		and player.echoes.DebugGUIPlease
			player.echoes.DebugGUIPlease = false
			CONS_Printf(player, "Echoes debug GUI are now off.")
		end
	else CONS_Printf(player, "Displays debug information for Echoes on the right side of the screen.") end
end)

local function DebugHUD(v, player, cam)
	if not SkinCheck(player)
		return
	end
	
	local echoes = player.echoes
	if echoes != nil and echoes.DebugGUIPlease
		local flags = V_MONOSPACE | V_SNAPTORIGHT| V_ALLOWLOWERCASE | 
				V_PERPLAYER | V_PURPLEMAP
		local DebugItems = {
			"Abyss Active State: " .. tostring(echoes.abyssactive), 
			"Abyss Alive: " .. tostring(echoes.abyss != nil and 
					echoes.abyss.valid),
			"Abyss Hidden: " .. tostring(echoes.hideabyss),
			"Custom 1 Press: " .. tostring(echoes.cust1press),
			"Starpost Num: " .. tostring(player.starpostnum), 
			"Last Starpost: " .. tostring(echoes.lastcheckhit),
			"Drowning Timer: " .. tostring(player.powers[pw_underwater]),
			"Space Suffocating Timer: " .. tostring(player.powers[pw_spacetime]),
			"Shield Flags: " .. tostring(echoes.abyss_shield), 
			"Thokked: " .. tostring(not not (player.pflags & PF_THOKKED)),
			"Jump Press: " .. tostring(echoes.jumppress), 
			"Void Launch: " .. tostring(echoes.voidlaunch),
			"Void Height: " .. tostring(echoes.voidheight),
			"Void Stamina: " .. tostring(echoes.voidstamina),
			"Void Glide Tumble: " .. tostring(echoes.voidtumble),
			"Void Cooldown: " .. tostring(echoes.voidcooldown),
			"Spin Press: " .. tostring(echoes.spinpress),
			"Rope Dropped: " .. tostring(echoes.ropedrop),
			"Phantom Twirl: " .. tostring(echoes.phanttwirl),
			"Phantom Twirl Timer: " .. tostring(echoes.twirltimer),
			"Crouching: " .. tostring(echoes.crouch),
			"Shadow Leap Charge: " .. tostring(echoes.leapcharge),
			"Shadow Leaping: " .. tostring(echoes.shadowleap),
			"Leap Charge Rising: " .. tostring(echoes.chargerise),
			"Leap Charge Hover Height: " .. tostring(echoes.chargeheight),
			"Leap Charge Ripple Timer: " .. tostring(echoes.chargeripple),
			"Stun Cooldown: " .. tostring(echoes.stuncooldown),
			"Super Transformation Timer: " .. tostring(echoes.transform),
			"Super Music Change: " .. tostring(echoes.primusic),
			"Super Floating Offset: " .. tostring(echoes.primflot),
			"Super Ascending: " .. tostring(echoes.primascend),
			"Hugging Skip: " .. tostring(echoes.skiphug),
			"Death Animation Type: " .. tostring(echoes.deathtype),
			"Death Animation Start: " .. tostring(echoes.dedstart)
		}
		local loff = 5
		for i, str in ipairs(DebugItems) do
			v.drawString(315, loff, str, flags, "small-right")
			loff = $ + 5
		end
	end
end

local ShieldTitle = {
	[SH_ELEMENTAL] = "ELEMENTAL",
	[SH_WHIRLWIND] = "WHIRLWIND",
	[SH_ARMAGEDDON] = "ARMAGEDDON"
}

local function AbyssHUD(v, player, cam)
	if not SkinCheck(player) or IsNiGHTS(player) or G_IsSpecialStage(gamemap)
		return
	end
	
	local echoes = player.echoes
	if echoes != nil and echoes.abyssactive != nil
		if not v.patchExists("ABBY")
			v.cachePatch("ABBY")
		end
		local add_y = 0
		if not hud.enabled("lives")
			add_y = 19
		elseif G_RingSlingerGametype() and not G_TagGametype()
			add_y = -7
		end
		local col1, col2 = ColorOpposite(player.skincolor)
		v.drawScaled(16 * FRACUNIT, (157 + add_y) * FRACUNIT, FRACUNIT / 2, 
				v.getSpritePatch("ABBY", echoes.abyssactive), V_SNAPTOLEFT | 
				V_SNAPTOBOTTOM | V_PERPLAYER | V_HUDTRANS, 
				v.getColormap(TC_DEFAULT, col1))
		v.drawString(34, 157 + add_y, "ABYSS", V_SNAPTOLEFT | V_SNAPTOBOTTOM | 
				V_PERPLAYER | V_YELLOWMAP | V_HUDTRANS, "left")
		local subtitle = ""
		local flags = V_SNAPTOLEFT | V_SNAPTOBOTTOM | V_PERPLAYER | V_HUDTRANS
		if echoes.abyssactive >= 3 and isSuper(player)
			subtitle = "PRIME"
		elseif echoes.abyss_shield != nil and echoes.abyss_shield != SH_NONE
			if echoes.abyss_shield & SH_FORCE
				subtitle = "FORCE"
			elseif ShieldTitle[echoes.abyss_shield & SH_NOSTACK] != nil
				subtitle = ShieldTitle[echoes.abyss_shield]
			elseif echoes.abyss_shield & SH_PROTECTFIRE
				subtitle = "FIRE"
			elseif echoes.abyss_shield & SH_PROTECTELECTRIC
				subtitle = "ELECTRIC"
			elseif echoes.abyss_shield & SH_PROTECTWATER
				subtitle = "WATER"
			end
		elseif echoes.abyssactive <= 0
			if echoes.hudflash
				flags = $ | V_REDMAP
			end
			if leveltime % 4 == 0
				echoes.hudflash = not $
			end
			subtitle = "DANGER!!"
		end
		v.drawString(34, 167 + add_y, subtitle, flags, "small")
	end
end

hud.add(DebugHUD, "game")
hud.add(AbyssHUD, "game")